BEGIN {

}

function GetEmail(s) {

	res=gensub("^.*[^a-zA-Z0-9._-]([a-zA-Z0-9._-]*@[a-zA-Z0-9.-]*)[^a-zA-Z0-9.-].*$", "\\1", "g", s);
	if (res !~ ".*@.*") res="";
	return tolower(res);
}

function GetValueN(s) {
	res = gensub("^.*: *([0-9]*)[^0-9]*$", "\\1", "g", s);
	return res;
}

function GetPassword(s) {
	res = gensub("^.*: '(.*)'(},|,)$", "\\1", "g", s);
	return res;
}

/'digest_members' *: *{/,/} */ {
	options[GetEmail($0)]=32;
}


/'members' *: *{/,/}/ {
	email=GetEmail($0);
	if (email in options) {} else {
		options[email]=0;
		}
}

/'user_options' *: *{/,/} */ {
	options[GetEmail($0)] += GetValueN($0);
}

/'passwords' *: *{/,/}/ {
	passwords[GetEmail($0)] = GetPassword($0);
}

END {
	nb_subscribers=0;
	print "" >  EXPL "/" LIST "/subscribers";
	for (email in options) {
		if (email == "") continue;
		opt=options[email];
		digest=0;
		visibility="noconceal";
		plain=0;
		ack=0;
		password=passwords[email];
		no_metoo=0;
		nomail=0;
		if (opt>=32) {
			digest=1;
			opt -= 32;
			}
		if (opt>=16) {
			visibility="conceal";
			opt -= 16;
			}
		if (opt>=8) {
			plain=1;
			opt -= 8;
			}
		if (opt>=4) {
			ack=1;
			opt -= 4;
			}
		if (opt>=2) {
			no_metoo=1;
			opt -= 2;
			}
		if (opt>=1) {
			nomail=1;
			opt -= 1;
			}
		if (nomail==1 && NOMAIL=="no") continue;

		if (nomail==1) {reception="nomail";}
		else if (digest==1) {reception="digest";}
		else {reception="mail";}
		printf("email %s\nvisibility %s\n", email, visibility) >> EXPL "/" LIST "/subscribers";
		if (reception != "mail") {
			printf("reception %s\n", reception)  >> EXPL "/" LIST "/subscribers";
			}
		printf("\n") >> EXPL "/" LIST "/subscribers";
		nb_subscribers += 1;
		printf("%s;%s\n", email, password) >> WDIR "/csv/import_users.csv";
		printf("%s;%s;%s;null;%s;%s;null;null;null;null;null\n", LIST, email, DATE, visibility, reception) >> WDIR "/csv/import_subscribers.csv";

		}
	printf("0 0 0 0 %s", nb_subscribers) >  EXPL "/" LIST "/stats";
}
